// WndMessageHolder.cpp

#include "StdAfx.h"

#include "WndMessageHolder.h"

#include <tchar.h>

#pragma comment(lib, "user32.lib")

using namespace BringUpTest;

WndMessageHolder::WndMessageHolder(void)
{
  TCHAR tstrBringUpMessage[46] = _T("{EF278EFA-CC40-45ef-B645-0996E5085FA4}");
#ifdef _DEBUG
  _tcscat_s(tstrBringUpMessage, sizeof(tstrBringUpMessage) / sizeof(TCHAR), _T("_debug"));
#endif
  WM_BRINGUP = RegisterWindowMessage(tstrBringUpMessage);
}

WndMessageHolder ^WndMessageHolder::GetInstance()
{
  if (!s_wmhInstance) s_wmhInstance = gcnew WndMessageHolder;
  return s_wmhInstance;
}

bool WndMessageHolder::PostMessage_(IntPtr hwnd_, int msg_, IntPtr wparam_, IntPtr lparam_)
{
  return ::PostMessage((HWND)(void *)hwnd_, msg_, (WPARAM)(void *)wparam_, (LPARAM)(void *)lparam_);
}

bool WndMessageHolder::SetForegroundWindow_(IWin32Window ^wnd_)
{
  return ::SetForegroundWindow((HWND)(void *)(wnd_->Handle));
}

Int32 WndMessageHolder::GetLastError_()
{
  return ::GetLastError();
}
